﻿Friend Class clsDataCollectionsDB

#Region " Private Variables "

    Private SqlConnection As New System.Data.SqlClient.SqlConnection
    Private SqlCommand As New System.Data.SqlClient.SqlCommand
    Private ServerName As String = "HAL"
    Private DatabaseName As String = "BTI_DataCollection"
    Private UserName As String = "sa"
    Private PassWord As String = "NoPasswordHere"

#End Region

#Region " Private Subs & Functions "

    Private Sub MakeSQLConn(ByVal ServerName As String, ByVal DatabaseName As String, ByVal Username As String, ByVal Password As String)

        Dim MyConnectionString As String = "data source=" & ServerName & ";initial catalog=" & DatabaseName & ";persist security info=False;user id=" & Username & ";password=" & Password & ";workstation id=SPACEGHOST;packet size=4096"
        SqlConnection.ConnectionString = MyConnectionString
        SqlCommand.Connection = SqlConnection

    End Sub

    Private Sub AddUpDateDatabase(ByVal SQL_Command As String)

        ' executes the nonquery SQL_Command

        MakeSQLConn(ServerName, DatabaseName, UserName, PassWord)
        Dim UpdateCommand As New System.Data.SqlClient.SqlCommand(SQL_Command, SqlConnection)
        UpdateCommand.Connection.Open()
        UpdateCommand.ExecuteNonQuery()
        UpdateCommand.Connection.Close()
        SqlCommand.Connection.Close()

    End Sub

    Private Function GetClockInKey(ByVal Employee As String, ByVal Job As String, ByVal Op As String) As String

        Dim TempKey As String = ""
        Dim TempSQL As String = "SELECT ClockInKey FROM ClockIn WHERE ( Employee = '" & Employee & "' AND Job = '" & Job & "' AND OP = '" & Op & "' );"
        MakeSQLConn(ServerName, DatabaseName, UserName, PassWord)
        SqlConnection.Open()
        SqlCommand.Connection = SqlConnection
        SqlCommand.CommandText = TempSQL
        Dim UserRecord As System.Data.SqlClient.SqlDataReader
        UserRecord = SqlCommand.ExecuteReader
        Do While UserRecord.Read
            On Error Resume Next
            TempKey = Trim(Str(UserRecord("ClockInKey")))
        Loop
        SqlConnection.Close()
        Return TempKey

    End Function

#End Region

#Region " Public Subs & Functions "

    Public Sub AddClockIn(ByVal ClockInData As clsTcp.ClockIn)

        Dim SQL_Command As String = "INSERT INTO ClockIn (Employee, Job, Op, SerialNumber, Machine, ClockInTime) VALUES ('" & ClockInData.Employee & "', '" & _
                                    ClockInData.Job & "', '" & ClockInData.JobOp & "', '" & ClockInData.SerialNumber & "', '" & ClockInData.Machine & "', '" & _
                                    Format(Now, "MM/dd/yyy hh:mm:ss") & "') ;"
        AddUpDateDatabase(SQL_Command)

    End Sub

    Public Sub AddClockOut(ByVal ClockOutData As clsTcp.ClockOut)

        Dim ClockInKey As String = GetClockInKey(ClockOutData.Employee, ClockOutData.Job, ClockOutData.JobOp)
        Dim SQL_Command As String = "INSERT INTO ClockOut (ClockInKey, Employee, Job, Op, Quantity, Scrap, ClockOutTime) VALUES (" & ClockInKey & ", '" & _
                                    ClockOutData.Employee & "', '" & ClockOutData.Job & "', '" & ClockOutData.JobOp & "', " & ClockOutData.Quantity & _
                                    ", " & ClockOutData.Scrap & ", '" & Format(Now, "MM/dd/yyy hh:mm:ss") & "') ;"
        AddUpDateDatabase(SQL_Command)

    End Sub

    Public Function ClockOutIsOK(ByVal ClockOutData As clsTcp.ClockOut) As Boolean

        Dim TempBool As Boolean = False
        Dim Count As Integer = 0
        Dim TempSQL As String = "SELECT COUNT(ClockIn.ClockInKey) AS Total FROM ClockIn LEFT OUTER JOIN ClockOut ON ClockIn.ClockInKey = ClockOut.ClockInKey " & _
                                "WHERE  (ClockIn.Employee = '" & ClockOutData.Employee & "') AND (ClockIn.Job = '" & ClockOutData.Job & "') AND " & _
                                "(ClockIn.Op = '" & ClockOutData.JobOp & "') AND (ClockOut.ClockOutKey IS NULL)"
        MakeSQLConn(ServerName, DatabaseName, UserName, PassWord)
        SqlConnection.Open()
        SqlCommand.Connection = SqlConnection
        SqlCommand.CommandText = TempSQL
        Dim UserRecord As System.Data.SqlClient.SqlDataReader
        UserRecord = SqlCommand.ExecuteReader
        Do While UserRecord.Read
            On Error Resume Next
            Count = UserRecord("Total")
        Loop
        SqlConnection.Close()
        If Count = 1 Then
            TempBool = True
        Else
            TempBool = False
        End If
        Return TempBool

    End Function

    Public Function ClockInIsOK(ByVal ClockInData As clsTcp.ClockIn) As Boolean

        Dim TempBool As Boolean = False
        Dim Count As Integer = 0
        Dim TempSQL As String = "SELECT COUNT(ClockIn.ClockInKey) AS Total FROM ClockIn LEFT OUTER JOIN ClockOut ON ClockIn.ClockInKey = ClockOut.ClockInKey " & _
                                "WHERE  (ClockIn.Employee = '" & ClockInData.Employee & "') AND (ClockIn.Job = '" & ClockInData.Job & "') AND " & _
                                "(ClockIn.Op = '" & ClockInData.JobOp & "') AND (ClockOut.ClockOutKey IS NULL)"
        MakeSQLConn(ServerName, DatabaseName, UserName, PassWord)
        SqlConnection.Open()
        SqlCommand.Connection = SqlConnection
        SqlCommand.CommandText = TempSQL
        Dim UserRecord As System.Data.SqlClient.SqlDataReader
        UserRecord = SqlCommand.ExecuteReader
        Do While UserRecord.Read
            On Error Resume Next
            Count = UserRecord("Total")
        Loop
        SqlConnection.Close()
        If Count = 0 Then
            TempBool = True
        Else
            TempBool = False
        End If
        Return TempBool

    End Function

#End Region

End Class
